<template>
  <modal
    :is="modals.get('date-picker')"
    :modal="modal"
    :value="task.deadlineAt"
    @input="
      task.$setAndSaveAttributes({ deadlineAt: $event });
      $emit('picked');
    "
    :title="`Select Deadline`"
    location="center"
  />
</template>

<script lang="ts">
import { usePersistentActions } from "@/use/persistentActions";
import DateEditor from "@/components/DateEditor.vue";
import { useModals, isModal } from "@/use/modal";
import Task from "@/models/Task";
import DatePickerVue from "../DatePicker.vue";

export default {
  mixins: [isModal()],
  components: { DateEditor },
  props: {
    task: {
      type: Task,
      required: true
    }
  },
  emits: ["picked"],
  setup(props) {
    return {
      modals: useModals({ DatePicker: DatePickerVue }),
      actions: usePersistentActions(props.task)
    };
  }
};
</script>
